//5、 利用分类给NSString扩展3个方法（Objective-C）
//1>    字符串反转(比如@”123”调用方法后返回@”321”)
//2>    计算英文字母的个数(比如@”5435abc54abc3AHJ5”调用方法后返回的是9)
//3>    去除字符串两端空格（比如@”  1235 45 ”调用方法后返回@”1235 45”）

#import <Foundation/Foundation.h>

/*
 定义分类的过程大致可分为以下几个步骤：
 第一步、创建一个带有接口的新文件，即创建已有类
 
 第二步、在新文件中添加需要扩展的方法及方法的实现，即需要添加的分类
 */
//NSString 表示将要添加分类的类名称，该类必须是已存在的。
//CamelCase 是为类添加的方法名称。
//只能添加方法，不能添加变量。
//头文件命名惯例:ClassName+CategoryName.h
@interface NSString (New)

- (NSString *)reverse;

- (int)countAlpha;

//去除字符串两端空格
- (NSString *)removeSpace;

@end

@implementation NSString (New)

//字符串反转
- (NSString *)reverse
{
    NSMutableArray *array = [NSMutableArray array];
    for (NSUInteger i = self.length ; i > 0; i--) {
        [array addObject:[NSString stringWithFormat:@"%c",[self characterAtIndex:i-1]]];
    }
    return [array componentsJoinedByString:@""];
}
//计算英文字母个数
- (int)countAlpha
{
    int count = 0;
    for (NSUInteger i = 0; i < self.length; i++) {
        if(isalpha([self characterAtIndex:i]))
            count++;
    }
    return count;
}
//去除字符串两端空格
- (NSString *)removeSpace
{
    NSMutableString *temp = [NSMutableString stringWithString:self];
    while (isblank([temp characterAtIndex:0])) {
        [temp deleteCharactersInRange:NSMakeRange(0, 1)];
    }
    while (isblank([temp characterAtIndex:temp.length-1])) {
        [temp deleteCharactersInRange:NSMakeRange(temp.length-1, 1)];
    }
    
    return [NSString stringWithString:temp];
}

@end




int main (int argc, const char * argv[])
{
   NSString *s1=@"123";
    NSLog(@"%@",[s1 reverse]);
    
    NSString *s2=@"5435abc54abc3AHJ5";
    NSLog(@"%d",[s2 countAlpha]);
    
    NSString *s3=@"  1235 45 ";
    NSLog(@"%@",[s3 removeSpace]);
    
    
    
  
}